/*
 * gdimg.cc
 * 
 * Extension to boutell's gd1.2
 * allows a float array to build an image
 * 
 * 1996nov26 dpwe@icsi.berkeley.edu
 * $Header: /n/yam/da/dpwe/src/tcl/gdtcl/RCS/gdimg.cc,v 1.1 1998/03/04 02:45:18 dpwe Exp dpwe $
 */
#include <malloc.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>

#include <floatArray/floatArray.H>

extern "C" {
#include "gd.h"
/* need C linkage ... */
void gdImageArrayImg(gdImagePtr im, int x1, int y1, 
		     floatArray *fa, int colormap[], int ncolors);
}

void gdImageArrayImg(gdImagePtr im, int x1, int y1, 
		     floatArray *fa, int colormap[], int ncolors)
{   /* Set a region in an image from an array of floats */
    int x,y,color;
    int rows = fa->Rows();
    int cols = fa->Cols();
    for(x=0; x<rows; ++x) {
	for(y=0; y<cols; ++y) {
	    // implicit transposition in reading row as x and col as y
	    color=(int)(ncolors*fa->Val(x, y));
	    if(color<0)		color = 0;
	    if(color>=ncolors)	color = ncolors-1;
	    // also, put row 0 at bottom for better matrixness
	    gdImageSetPixel(im, x1+x, y1+(cols-1-y), colormap[color]);
	}
    }
}
