#
# gdtcl_init.tcl
#
# File to setup the Gdtcl package.
# Mainly this just loads the dynamic library, but it also ensures the 
# prerequisite libraries are loaded.
#
# 1998feb02 dpwe@icsi.berkeley.edu
# $Header: /n/yam/da/dpwe/src/tcl/gd1.2/RCS/gdtcl_init.tcl.in,v 1.1 1998/03/04 02:45:18 dpwe Exp $

# We need: Farray_otcl

# A list of pairs of package names and commands to check for them
set _needed_pkgs {{Farray floatArray}}

# Request the packages
foreach pkg $_needed_pkgs {
    set pkgName [lindex $pkg 0]
    set pkgCmd  [lindex $pkg 1]

    # Find the package through the standard mechanism
    package require $pkgName

    # Make sure that each package is genuinely loaded by executing 
    # the autoload cmd if necessary
    if {[info commands $pkgCmd] == ""} {
	# "package require" just sets up the auto_index.  Make sure we 
	# actually load it.
	eval $auto_index($pkgCmd)
    }
}

# Load our library (includes the "package provide" command)
load [file join [file dirname [info script]] libgdtcl.so]
